=== src/eapol_auth/Makefile ===
LIB_OBJS = eapol_auth_sm.o eapol_auth_dump.o
include ../lib.rules
