=== debian/changelog ===
wpa (2:2.10-25) unstable; urgency=medium

  [ Mitchell Augustin ]
  * Bump DEFAULT_BSS_MAX_COUNT to 1000.

  [ Lukas Märdian ]
  * d/control: change Maintainer to Networking team.

  [ Andrej Shadura ]
  * Enable MBO, OWE, IEEE 802.11w, P2P, SAE and SuiteB-192 in udebs
    (Closes: #1109197).
  * Enable CONFIG_MATCH_IFACE (Closes: #1120302)
  * Install udeb wpa-supplicant into /usr/sbin.
  * Drop package-supports-alternative-init-but-no-init.d-script lintian
    override.

  [ Luca Boccassi ]
  * Use sysusers.d for netdev group.

  [ ValdikSS ]
  * Add support for wps_disabled (wpa-wps-disabled) option to the ifupdown
    integration scripts.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 08 Nov 2025 10:09:39 +0100

wpa (2:2.10-24) unstable; urgency=medium

  [ Hlib Korzhynskyy ]
  * SECURITY UPDATE: Encrypted element reusage
    - debian/patches/CVE-2022-37660.patch: Add hostapd_dpp_pkex_clear_code()
      and wpas_dpp_pkex_clear_code(), and clear code reusage in
      ./src/ap/dpp_hostapd.c and ./wpa_supplicant/dpp_supplicant.c
    - CVE-2022-37660.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 22 Mar 2025 07:06:15 +0100

wpa (2:2.10-23) unstable; urgency=medium

  * Apply upstream patch to decrease verbosity of syslog logging.
    Closes: #1101013.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 21 Mar 2025 19:51:50 +0100

wpa (2:2.10-22) unstable; urgency=medium

  * Only load libraries from trusted path (CVE-2024-5290, LP: #2067613).

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 06 Aug 2024 22:08:38 +0200

wpa (2:2.10-21.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix CVE-2023-52160 (Closes: #1064061):
    The implementation of PEAP in wpa_supplicant allows
    authentication bypass. For a successful attack,
    wpa_supplicant must be configured to not verify
    the network's TLS certificate during Phase 1
    authentication, and an eap_peap_decrypt vulnerability
    can then be abused to skip Phase 2 authentication.
    The attack vector is sending an EAP-TLV Success packet
    instead of starting Phase 2. This allows an adversary
    to impersonate Enterprise Wi-Fi networks.

 -- Bastien Roucariès <rouca@debian.org>  Sun, 28 Apr 2024 21:07:32 +0000

wpa (2:2.10-21) unstable; urgency=medium

  [ Jan Van Buggenhout ]
  * Work around missing /dev/stderr and /dev/stdout during early boot.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 25 Dec 2023 10:47:06 +0100

wpa (2:2.10-20) unstable; urgency=medium

  * Add a trailing newline to the patch series file.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 10 Dec 2023 17:03:00 +0100

wpa (2:2.10-19) unstable; urgency=medium

  [ Andrey Skvortsov ]
  * Override ieee80211w from pmf for AP mode in wpa_supplicant
    (Closes: #1057494)

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 10 Dec 2023 16:17:49 +0100

wpa (2:2.10-18) unstable; urgency=medium

  * Use "command" when calling actual ifupdown and not its shell wrappers
    (Closes: #1056976)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 30 Nov 2023 10:01:49 +0100

wpa (2:2.10-17) unstable; urgency=medium

  [ Guillem Jover ]
  * Do not hardcode absolute pathnames to third-party commands.
  * Fully move files from / to canonical /usr locations
    (Closes: #1056976).

 -- Andrej Shadura <andrew.shadura@collabora.co.uk>  Tue, 28 Nov 2023 13:24:46 +0100

wpa (2:2.10-16) unstable; urgency=medium

  * Move binaries to /usr.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 26 Nov 2023 12:01:06 +0000

wpa (2:2.10-15) unstable; urgency=medium

  * Apply proposed upstream patch:
    - Abort ongoing scan:
      Along with canceling queued scan, abort ongoing scan if any, this
      ensures Wi-Fi interface is in usable state after disconnect is issued,
      else subsequent scan after disconnect might fail with EBUSY.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 30 Aug 2023 14:28:29 +0200

wpa (2:2.10-14) unstable; urgency=medium

  * Drop a patch with a missing dependency.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 23 Aug 2023 00:37:01 +0200

wpa (2:2.10-13) unstable; urgency=medium

  [ Gioele Barabucci ]
  * d/rules: Install dbus policy in /usr instead of /etc (Closes: #1035609).

  [ Andrej Shadura ]
  * Update lintian override info format in d/wpasupplicant.lintian-overrides
  * Set upstream metadata fields: Repository.
  * Apply upstream patches:
    - wnm: Choose best available bss, not just first one
    - Fix wpa_supplicant configuration parsing error
    - Fix multiple BSSID STA aid count.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 22 Aug 2023 21:34:36 +0200

wpa (2:2.10-12) unstable; urgency=medium

  * Prevent hostapd units from being started if there’s
    no config provided (Closes: #1028088).
  * hostapd: Enable 802.11ax support (Closes: #1013732).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 24 Feb 2023 14:01:35 +0100

wpa (2:2.10-11) unstable; urgency=medium

  * Drop security level to 0 with OpenSSL 3.0 when using TLS 1.0/1.1
    (Closes: #1011121, LP: #1958267)
  * Drop dependency on lsb-base.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 31 Jan 2023 12:58:02 +0100

wpa (2:2.10-10) unstable; urgency=medium

  * Configure wpa_supplicant.service to create control sockets owned by group netdev
    (Closes: #1012844)

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 21 Dec 2022 10:03:29 +0100

wpa (2:2.10-9) unstable; urgency=medium

  [ Sebastien Bacher ]
  * debian/patches/allow-legacy-renegotiation.patch:
    Allow legacy renegotiation to fix PEAP issues with some servers
    (Closes: #1010603, LP: #1962541)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 05 May 2022 11:23:33 +0100

wpa (2:2.10-8) unstable; urgency=medium

  * Pull the defconfig updates from the upstream’s Git.
  * Add an upstream patch: AP: guard FT-SAE code with CONFIG_IEEE80211R_AP.
  * Declare Breaks against NM without this patch (Closes: #1003907):
    - supplicant: enable WPA3 transition mode only when interface supports PMF


