=== debian/tests/control ===
Tests: build-libwpa-test
Depends:
 build-essential,
 @
Restrictions: allow-stderr
