## wpa 2.10-6ubuntu2+11.0trisquel1

=== debian/changelog ===
wpa (2:2.10-6ubuntu2+11.0trisquel1) aramo; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 30 Nov 2022 19:46:40 +0000

wpa (2:2.10-6ubuntu2) jammy; urgency=medium

  * debian/patches/lower_security_level_for_tls_1.patch:
    - set the OpenSSL security level to 0 if that is the only option to
      continue the TLS negotiation, i.e., when TLS 1.0/1.1 are still allowed
      in wpa_supplicant default configuration and OpenSSL 3.0 with the
      constraint on MD5-SHA1 use. Patch proposed by Jouni Malinen on
      the upstream mailinglist (lp: #1958267)

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 03 Jun 2022 23:28:07 +0200

wpa (2:2.10-6ubuntu1) jammy; urgency=medium

  * debian/patches/allow-legacy-renegotiation.patch:
    allow legacy renegotiation to fix PEAP issues with some servers
    (lp: #1962541)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 05 May 2022 11:31:26 +0200
