=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: wpa
-Maintainer: Debian Networking Team <team+networking@tracker.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>
 Section: net
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
- dh-sequence-installsysusers,
  libdbus-1-dev,
  libssl-dev,
  qtbase5-dev [linux-any] <!pkg.wpa.nogui>,
@@ -18,8 +17,8 @@
  libbsd-dev [kfreebsd-any],
  libreadline-dev,
  pkgconf | pkg-config,
- docbook-to-man <!nodoc>,
- docbook-utils <!nodoc>,
+ docbook-to-man,
+ docbook-utils
 Standards-Version: 4.4.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/wpa
@@ -32,6 +31,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
  ${misc:Depends},
+ lsb-base
 Description: access point and authentication server for Wi-Fi and Ethernet
  IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/WPA3/EAP Authenticator
  .
@@ -73,7 +73,8 @@
 Multi-Arch: foreign
 Depends: ${shlibs:Depends},
  ${misc:Depends},
-Breaks: network-manager (<< 1.36.4-2~)
+ lsb-base,
+ adduser
 Suggests: wpagui,
  libengine-pkcs11-openssl
 Description: client support for WPA and WPA2 (IEEE 802.11i)
