## wpa 2.10-6ubuntu2.2+11.0trisquel1

=== debian/changelog ===
wpa (2:2.10-6ubuntu2.2+11.0trisquel1) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 19 Mar 2025 20:50:35 +0000

wpa (2:2.10-6ubuntu2.2) jammy-security; urgency=medium

  * SECURITY UPDATE: Encrypted element reusage.
    - debian/patches/CVE-2022-37660.patch: Add hostapd_dpp_pkex_clear_code()
      and wpas_dpp_pkex_clear_code(), and clear code reusage in
      ./src/ap/dpp_hostapd.c and ./wpa_supplicant/dpp_supplicant.c
    - CVE-2022-37660

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Mon, 24 Feb 2025 16:09:28 -0330

wpa (2:2.10-6ubuntu2.1) jammy-security; urgency=medium

  * SECURITY UPDATE: loading arbitrary shared objects, privilege escalation
    - debian/patches/lib_engine_trusted_path.patch: Allow shared objects
      to only be loaded from /usr/lib, thanks to mdeslaur
    - CVE-2024-5290 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Mon, 05 Aug 2024 13:29:26 +0530
