## wpa 2.10-6ubuntu2.3+11.0trisquel1

=== wpa_supplicant/Makefile ===
--- 
+++ 
@@ -170,7 +170,7 @@
 endif
 
 ifdef CONFIG_EAPOL_TEST
-CFLAGS += -Werror -DEAPOL_TEST
+CFLAGS += -DEAPOL_TEST
 endif
 
 ifdef CONFIG_CODE_COVERAGE
