=== debian/changelog ===
wpa (2:2.10-6ubuntu2.3+11.0trisquel1) aramo; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 07 Oct 2025 12:52:36 +0000

wpa (2:2.10-6ubuntu2.3) jammy; urgency=medium

  * Bump DEFAULT_BSS_MAX_COUNT to 1000 (LP: #2117180)

 -- Mitchell Augustin <mitchell.augustin@canonical.com>  Mon, 21 Jul 2025 18:13:31 -0500
