=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: wpa
 Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>
 Section: net
