## wpa 2.10-21ubuntu0.2trisquel1

=== debian/changelog ===
wpa (2:2.10-21ubuntu0.2trisquel1) ecne-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 16 Mar 2025 10:08:12 +0000

wpa (2:2.10-21ubuntu0.2) noble-security; urgency=medium

  * SECURITY UPDATE: Encrypted element reusage.
    - debian/patches/CVE-2022-37660.patch: Add hostapd_dpp_pkex_clear_code()
      and wpas_dpp_pkex_clear_code(), and clear code reusage in
      ./src/ap/dpp_hostapd.c and ./wpa_supplicant/dpp_supplicant.c
    - CVE-2022-37660

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Fri, 21 Feb 2025 17:33:52 -0330

wpa (2:2.10-21ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: loading arbitrary shared objects, privilege escalation
    - debian/patches/lib_engine_trusted_path.patch: Allow shared objects
      to only be loaded from /usr/lib, thanks to mdeslaur
    - CVE-2024-5290

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Fri, 02 Aug 2024 17:36:25 +0530

wpa (2:2.10-21build4) noble; urgency=medium

  * No-change rebuild against libssl3t64 and libqt5core5t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 14 Apr 2024 23:43:08 +0100

wpa (2:2.10-21build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:25:51 +0000

wpa (2:2.10-21build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:30:42 +0000

wpa (2:2.10-21build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:16:39 +0000
